Videoarchiver alpha
====================

Some short description of files and instructions. Compiled binary is in ./out/artifacts/videoarchiver/ 
(or probably copied somewhere closer to the root)

Usage instructions
------------------

There is no -h or --help switch currently but you can get help by calling the program without any arguments
standard usage is:

```
java -jar videoarchiver [command] -i [input file] -o [output file]
```

Every other argument is optional (if there will be any error just pass them something random)

### Commands

* ``fixJson`` - tries to fix JSON broken by comment downloader - in case you are wondering what is broken on that JSON -
it has no root element so we need to close it inside [] and add "," after every line except the last one.
* ``convert`` - converts json to html, accepts optional -v to link it with video. Currently css has to be linked
manually with any css file using ``<link rel="stylesheet" type="text/css" href="path/To/CSS.css"/>`` or it can be 
added directly in inspect element in firefox (not sure about chrome)
    * I tried to give all tags some meaningful classes so they can be styled
    * Example css included
* ``avatars`` - Downloads all avatars from -i json file - dumps them to current dir
* All command parsing logic and default values are in file Config.kt

File descriptions
-----------------

* ``Main.kt`` and ``Config.kt`` - mostly argument parsing and starting logic
* ``Utils.kt`` - everything I didn't know where to put
    * Contains - avatar downloading and JsonFixing 
* ``HtmlWriter.kt`` - Well.. it writes html it can look a bit messy so I would rather recommend inspecting
the resulting html if you want to get .class names
* ``Comment.kt`` & ``MetaData.kt`` - contains JSON model of comments and some MetaData sketch
* All methods should have at least some form of javadoc.

### Building from source
 
Not gonna lie, I dont know how to do it, I just hit F5 in intelij or build Artifact and run that.
I want to learn it (and even pack JRE with the .jar if we would decide to stick to kotlin) but currently I don't have the time for that.
Feel free to decompile the binary and verify it (or build it if you know how).

Later I would like to either use [Kscript](https://github.com/holgerbrandl/kscript) or rewrite it in python as 
was already mentioned in /end/ post.

#### Distribution of source/colaboration

I don't know how much you'll want to help with development. But I am not sure about colaborating on this over imageboard
Like we can still post update in /go/ but I don't know if it wouldn't be just making visual mess eventually.

I was thinking of gihub, gitlab, gitgud, gitea (not sure if gitea is only selfhosted). But theres probably lot
of time to decide about that. It's just that there are porbably better ways to share source than to pass it around zip files like 
in 70s. (But in the end it's not necessary, just a suggestion)
