/**Contains data that will be serialized to JSON after packing.
 * This is for use with Machine reading as everything should be also included in main HTML for user friendliness.
 * */
data class MetaData(
    val videoName :String?,
    /**Channel video was uploaded to*/
    val channel :String?,
    val description :String?,
    val originalUrl :String?,
    /**Original upload date in UNIX time stamp*/
    val uploadDate :Long?,
    /**UNIX timestamp of date metadata file was generated*/
    val archivalDate :Long?,
)
